/*
 * Copyright (C) 2001/2003 The Honeynet Project.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by The Honeynet Project.
 * 4. The name "The Honeynet Project" may not be used to endorse or promote
 *    products derived from this software without specific prior written
 *    permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#pragma ident "@(#)$Id: net.h,v 1.6 2003/09/01 08:23:21 job Exp $"

#include <sys/stream.h>
#include <sys/ethernet.h>

/* this was only necessary for debug stuff on sparc
#include <sys/hme_mac.h>
#include <sys/hme.h>
*/

#include <netinet/udp.h>
#if SOL_MINVER >= 8
# include <inet/ip_if.h>
# include <netinet/ip6.h>
# define       ipif_local_addr ipif_lcl_addr
# ifndef       V4_PART_OF_V6
#  define      V4_PART_OF_V6(v6)       v6.s6_addr32[3]
# endif
#endif

#define    MTYPE(m)        ((m)->b_datap->db_type)

in_addr_t inet_addr(const char *cp);

extern struct qinit *old_rqinit;
extern struct qinit *old_wqinit;

extern struct qinit new_rqinit;
extern struct qinit new_wqinit;

extern queue_t *qinp;
extern queue_t *qoutp;

extern struct ether_addr ether_src;
extern struct ether_addr ether_dst;

extern struct in_addr ip_local;
extern struct in_addr ip_dst;

int iprput(queue_t *q, mblk_t *mb);
int ipwput(queue_t *q, mblk_t *mb);
int new_strrput(queue_t *, mblk_t *);
int send_packet(char *buf, unsigned int len, int fd, int fromuser, uint16_t type);
mblk_t *makemblk(unsigned int size, int type);
int send_and_ack(struct vnode *vp, mblk_t **mpp, rval_t *retvalp);
void ether_aton(const char *s, struct ether_addr *eap);

extern struct vnode *sbkvp;
extern int stream_open;


